package modelage;

import java.util.Random;

import org.jgap.*;
import org.jgap.impl.*;

public class MODELAGEMinimizing {

	public static double ArKGeneRangeMiddle = 0;
	public static int noOfInputValues = 0;
	
	public static double[] ArPerKDiagFinal;
	public static double[] ArPerKDetrFinal;
	public static double[] KdetrPerKdiagFinal;
	
	
	
	private static final int MAX_ALLOWED_EVOLUTIONS = 100;
	private static final int NO_OF_CYCLES = 5000;
	private static int NO_OF_CALCULATIONS;
	
	private static FitnessFunction myFunc;
	private static Genotype population = null;
	private static Configuration conf;

	private static boolean ageDiagFixed = false;
	private static boolean ageDetrFixed = false;
	private static double ageDiagLowValue = 0;
	private static double ageDetrLowValue = 0;
	private static double ageDiagHighValue = 0;
	private static double ageDetrHighValue = 0;
	
	private static boolean KDiagFixed = false;
	private static boolean KDetrFixed = false;
	private static double KDiagLowValue = 0;
	private static double KDetrLowValue = 0;
	private static double KDiagHighValue = 0;
	private static double KDetrHighValue = 0;	

	private static double KdetrPerKdiagLow = 0;
	private static double KdetrPerKdiagHigh = 0;
	private static double KdetrPerKdiag = 0;
	
	private static double ArPerKDiag = 0;
	private static double ArPerKDetr = 0;
	
	private static double bestFitnessValue = 0;
	private static double bestKdetrPerKdiag = 0;
	private static double bestArPerKDiag = 0;
	private static double bestArPerKDetr = 0;
	
	private static double[] initialWtValues;
	private static double[] initialArKValues;
	
	private static double randomError = 0;
	private static double systematicError = 0;
	private static double systematicAge = 0;	
	
	private static double fitnessValue = 0;
	
	
	
	
	/**
	 * initialize the GA calculations, copies initial values and sets values of genes at appropriate ranges
	 */
	public static void beginEvolution(double initial_Ar_K_Values[], double initial_Wt_Values[], int no_Of_Input_Values, 
	  double random_Error, double systematic_Error, double systematic_Age, int no_Of_Calculations){

		randomError = random_Error;
		systematicError = systematic_Error;
		systematicAge = systematic_Age;
		NO_OF_CALCULATIONS = no_Of_Calculations;//set number of calculation cycles
		
		initialWtValues = new double[initial_Wt_Values.length];
		initialArKValues = new double[initial_Ar_K_Values.length];
		for (int i=0; i < initial_Ar_K_Values.length; i++){
			initialWtValues[i] = initial_Wt_Values[i];
			initialArKValues[i] = initial_Ar_K_Values[i];	
		}
		
		bestFitnessValue = 0;//reset fitness value which compares results from subsequent calculations
		conf = new DefaultConfiguration();
		Configuration.reset();//configuration resetting is necessary for more than one initialization of calculations
		conf.setPreservFittestIndividual(true);
		conf.setKeepPopulationSizeConstant(false);
		
	//Set the fitness function we want to use
		myFunc = new MODELAGEFitnessFunction(initial_Ar_K_Values, initial_Wt_Values, no_Of_Input_Values);
		try {
			conf.setFitnessFunction(myFunc);
		} catch (InvalidConfigurationException e) {
			e.printStackTrace();
		}
	
    	//Genes construction
		Gene[] sampleGenes = new Gene[3];
		try {
		//fixes value of diagenetic age
			if(ageDiagFixed == true){
				sampleGenes[0] = new DoubleGene(conf, ArKCalculate(ageDiagLowValue), ArKCalculate(ageDiagHighValue)); //ArK diag
			}else{
				sampleGenes[0] = new DoubleGene(conf, 0, ArKGeneRangeMiddle); //ArK diag
			}
		//fixes value of detrital age
			if(ageDetrFixed == true){
				sampleGenes[1] = new DoubleGene(conf, ArKCalculate(ageDetrLowValue), ArKCalculate(ageDetrHighValue)); //ArK diag
			}else{
				sampleGenes[1] = new DoubleGene(conf, ArKGeneRangeMiddle, ArKGeneRangeMiddle * 6); //ArK detr
			}
		//fixes value of Kdetr/Kdiag	
			if(KDetrFixed == true && KDiagFixed == true){
				KdetrPerKdiagLow = KDetrLowValue/KDiagHighValue;
				KdetrPerKdiagHigh = KDetrHighValue/KDiagLowValue;			
				sampleGenes[2] = new DoubleGene(conf, KdetrPerKdiagLow, KdetrPerKdiagHigh); //Kdetr/Kdiag
			} else{
				sampleGenes[2] = new DoubleGene(conf, 0, 4);
			}
			IChromosome sampleChromosome = null;
			sampleChromosome = new Chromosome(conf, sampleGenes);
			conf.setSampleChromosome(sampleChromosome);
			conf.setPopulationSize(5);
		} catch (InvalidConfigurationException e) {
			e.printStackTrace();
		}

		population = null;
    	//initialize the population randomly
		try {
			population = Genotype.randomInitialGenotype(conf);
		} catch (InvalidConfigurationException e) {
			e.printStackTrace();
		}
 	}

	/**
	 * method that coordinates GA calculations
	 */
	public static Object Evolution() {
		try {
			ArPerKDiagFinal = new double[NO_OF_CALCULATIONS];
			ArPerKDetrFinal = new double[NO_OF_CALCULATIONS];
			KdetrPerKdiagFinal = new double[NO_OF_CALCULATIONS];

			for (int z = 0; z < NO_OF_CALCULATIONS; z++ ){
			//before every cycle best values are resetted	
				bestFitnessValue = 0;
				bestArPerKDiag = 0;
				bestArPerKDetr = 0;
				bestKdetrPerKdiag = 0;
        	
				MODELAGE.progressLabel.setText("progress:   " + (z+1) + "...");	
			//errors	
				double[] initialIkValues = new double[noOfInputValues];
				for (int i = 0; i < noOfInputValues; i++){
					 initialIkValues[i] = addNoise(initialWtValues[i], randomError, 0);
					 MODELAGEFitnessFunction.initialWtValues[i] = initialIkValues[i];
				}
			//internal cycles of GA
				for (int k = 0; k<NO_OF_CYCLES; k++){
					int progress = (int)((k+1)/(double)NO_OF_CYCLES*100.0);
					MODELAGE.updateStatus(progress);//update of progress bar
    		
				// Now we initialize the population randomly
					try {
						population = Genotype.randomInitialGenotype(conf);
					} catch (InvalidConfigurationException e) {
						e.printStackTrace();
					}
				//internal evolutions of GA
					for (int i = 0; i < MAX_ALLOWED_EVOLUTIONS; i++) {
						if (Thread.interrupted()) {
							throw new InterruptedException();
						}
						population.evolve();
					}	
    		
				//select the best solution with the highest fitness value after performation of MAX_ALLOWED_EVOLUTIONS	
					IChromosome bestSolutionSoFar = population.getFittestChromosome();
              
					fitnessValue =  bestSolutionSoFar.getFitnessValue();
					ArPerKDiag = MODELAGEFitnessFunction.getValueOfChromosome(bestSolutionSoFar, 0);
					ArPerKDetr = MODELAGEFitnessFunction.getValueOfChromosome(bestSolutionSoFar, 1);
					KdetrPerKdiag = MODELAGEFitnessFunction.getValueOfChromosome(bestSolutionSoFar, 2);
        
				//substitues previous results if we have now better ones  
					if (fitnessValue > bestFitnessValue){
						bestFitnessValue = fitnessValue;
						bestArPerKDiag = ArPerKDiag;
						bestArPerKDetr = ArPerKDetr;
						bestKdetrPerKdiag = KdetrPerKdiag;
					}
				}
				ArPerKDiagFinal[z] = bestArPerKDiag;
				ArPerKDetrFinal[z] = bestArPerKDetr;
				KdetrPerKdiagFinal[z] = bestKdetrPerKdiag;
				
				presentResults(bestArPerKDiag, bestArPerKDetr, bestKdetrPerKdiag, bestFitnessValue);
			
			//printing
        		ResultsPanel.setInitialWtValues(initialWtValues);
        		ResultsPanel.setInitialArKValues(initialArKValues);
        		
        		double[] modifiedIkValues = new double[initialIkValues.length];
        		double[] modifiedArKValues = new double[initialArKValues.length];
        		
        		for (int i=0; i<noOfInputValues; i++){
        			modifiedIkValues[i] = IkCalculate(initialIkValues[i], bestKdetrPerKdiag);//correction for Kdetr/Kdiag
        			modifiedIkValues[i] = addNoise(modifiedIkValues[i], 0, systematicError);//correction for systematic error
        		//correction of Ar K values	
        			if (MODELAGE.systematicAgeKnown == true){
        				modifiedArKValues[i] = ArKCorrectToDetritialComponent (initialArKValues[i], systematicError, systematicAge);
        			} else {
        				modifiedArKValues[i] = initialArKValues[i];
        			}
        		}

        		ResultsPanel.setModifiedWtValues(modifiedIkValues);
        		ResultsPanel.setModifiedArKValues(modifiedArKValues);
        		
				ResultsPanel.setArKEndMemberValues (bestArPerKDiag, bestArPerKDetr);
        		ResultsPanel.geneticPerformed = 1;
			}
			presentFinalResults(bestArPerKDiag, bestArPerKDetr, bestKdetrPerKdiag, bestFitnessValue);
		}
		catch (InterruptedException e) {
      		return "Interrupted";
      	}
      	return "All Done";
      
	}


	
  


//============================ backup methods  ================================   
  
  	/**
  	 * sets number of input values
  	 */
  	public static void setNoOfInputValues(int noOfInputValuesGiven){
  		noOfInputValues = noOfInputValuesGiven;
  	}
  	   
    /**
     * sets the flag informing that K diagenetic is fixed
     */
  	public static void fixKDiag (double KDiagLowValueGiven, double KDiagHighValueGiven){
  		KDiagFixed = true;
  		KDiagLowValue = KDiagLowValueGiven;
  		KDiagHighValue = KDiagHighValueGiven;
    	}
    
  	/**
  	 * sets the flag informing that K detrital is fixed
  	 */
  	public static void fixKDetr (double KDetrLowValueGiven, double KDetrHighValueGiven){
  		KDetrFixed = true;
  		KDetrLowValue = KDetrLowValueGiven;
  		KDetrHighValue = KDetrHighValueGiven;
    	}
    
  	/**
  	 * sets the flag informing that diagenetic age is fixed
  	 */
  	public static void fixAgeDiag (double ageDiagLowValueGiven, double ageDiagHighValueGiven){
  		ageDiagFixed = true;
  		ageDiagLowValue = ageDiagLowValueGiven;
  		ageDiagHighValue = ageDiagHighValueGiven;
   	}
  	
   	/**
     * sets the flag informing that detrital age is fixed
     */
  	public static void fixAgeDetr (double ageDetrLowValueGiven, double ageDetrHighValueGiven){
  		ageDetrFixed = true;
  		ageDetrLowValue = ageDetrLowValueGiven;
  		ageDetrHighValue = ageDetrHighValueGiven;
    	}
  	
    /**
     * resets all flags
     */
  	public static void unfixAll(){
  		KDiagFixed = false;
  		KDetrFixed = false;
  		ageDetrFixed = false;
  		ageDiagFixed = false;
    	}
  	
  	


    

	/**
	 * Adds random changes from assumed range to initial value
	 */
	private static double addNoise(double initialValue, double randomNoiseRange, double systematicNoiseRange){
		Random rand = new Random();
		double step = 0;
		boolean sign;
		double finalValue = 0;
		        
		step = rand.nextDouble();
		sign = rand.nextBoolean();
  
	//initial value + random noise + correction that percent of diagenetic illite is of detritial origin 
	//initial value corresponds to %wt of detritial component	  
		if (MODELAGE.systematicAgeKnown == true){
			if (sign == true) //plus
				finalValue =  initialValue + step * randomNoiseRange;
			else //minus
				finalValue =  initialValue - step * randomNoiseRange;
		} else {
			if (sign == true) //plus
				finalValue =  initialValue + step * randomNoiseRange + (100 - initialValue) * systematicNoiseRange/100;
			else //minus
				finalValue =  initialValue - step * randomNoiseRange + (100 - initialValue) * systematicNoiseRange/100;
		}
		return finalValue;
	}

  	/**
  	 * calculates Ik if amount of detrital fraction and Kdetrital/Kdiagenetic ratio is known
  	 */
  	private static double IkCalculate(double detritic_percent, double KdetPerKdiag){
  		return (detritic_percent * KdetPerKdiag)/(detritic_percent * KdetPerKdiag + (100-detritic_percent))*100; //range 0-1
  	}  	  
  	
    /**
     * calculates age (in Ma) from 40Ar/40K
     */   
    private static double ageCalculate(double KArRelation) {
    	return Math.log((1.4263 * KArRelation/100) + 1) / 5.543 * 10000; //returns age in Ma
    }
    
    /**
     * calculates 40Ar/40K from age (in Ma)
     */
    private static double ArKCalculate(double age) {
    	return (Math.exp(age/10000*5.543) - 1)/1.4263 * 100;
    }
  	
    /**
     * correction to 40Ar/40K if age of 1M detrital component is known
     */
	private static double ArKSubstractDetritialComponent (double ArKdiag, double systematicError, double systematicAge){						
		return (ArKdiag * 100 - systematicError * ArKCalculate(systematicAge))/(100 - systematicError);
	}

	/**
	 * correction to 40Ar/40K if age of 1M detrital component is known
	 */
	private static double ArKCorrectToDetritialComponent (double ArKTotal, double systematicError, double systematicAge){
		return (100 * ArKTotal - systematicError * ArKCalculate(systematicAge))/(100 - systematicError);
	}
 
    /**
     * round values with particular places after comma
     */
   	private static double round(double val, int places) {
       	long factor = (long)Math.pow(10,places);
       	val = val * factor;
       	long tmp = Math.round(val);
       	return (double)tmp / factor;
    }
  		
    /**
     * present results of particular cycle of calculation on screen	
     */
  	private static void presentResults(double best_Ar_K_Diag, double best_Ar_K_detr, double best_Kdetr_Per_Kdiag, double best_Fitness_Value){
  		double KDiagLowResult = 0;
  		double KDiagHighResult = 0;
  		double KDetrLowResult = 0;
  		double KDetrHighResult = 0;
  		
  	//different appearances if both Kdiag or Kdetr are fixed or if only one of these values
  		if (KDetrFixed == true && KDiagFixed == true){	   
  			if ((KDetrHighValue - KDetrLowValue) < (KDiagHighValue - KDiagLowValue)){
  				KDiagLowResult = round((1/best_Kdetr_Per_Kdiag)*KDetrLowValue, 3);
  				KDiagHighResult = round((1/best_Kdetr_Per_Kdiag)*KDetrHighValue, 3);
  				KDetrLowResult = round(KDetrLowValue, 3);
  				KDetrHighResult = round(KDetrHighValue, 3);
  					if (KDetrLowResult < KDetrLowValue) KDetrLowResult = KDetrLowValue;
  			   		if (KDetrHighResult > KDetrHighValue) KDetrHighResult = KDetrHighValue;
  			   		if (KDiagLowResult < KDiagLowValue) KDiagLowResult = KDiagLowValue;
  			   		if (KDiagHighResult > KDiagHighValue) KDiagHighResult = KDiagHighValue;
  			} else {
  				KDiagLowResult = round(KDiagLowValue, 3);
  				KDiagHighResult = round(KDiagHighValue, 3);
  				KDetrLowResult = round((best_Kdetr_Per_Kdiag*KDiagLowValue), 3);
  				KDetrHighResult = round((best_Kdetr_Per_Kdiag*KDiagHighValue), 3);
  					if (KDetrLowResult < KDetrLowValue) KDetrLowResult = KDetrLowValue;
  					if (KDetrHighResult > KDetrHighValue) KDetrHighResult = KDetrHighValue;
  			   		if (KDiagLowResult < KDiagLowValue) KDiagLowResult = KDiagLowValue;
  			   		if (KDiagHighResult > KDiagHighValue) KDiagHighResult = KDiagHighValue;
  			}  
  			MODELAGE.KDetrLabel.setText("K detr                " + KDetrLowResult + " - " + KDetrHighResult);
  			MODELAGE.KDiagLabel.setText("K diag                "  + KDiagLowResult + " - " + KDiagHighResult);	
  		} else if (KDetrFixed == true){
  			KDiagLowResult = round((1/best_Kdetr_Per_Kdiag)*KDetrLowValue, 3);
  			KDiagHighResult = round((1/best_Kdetr_Per_Kdiag)*KDetrHighValue, 3);
  			KDetrLowResult = round(KDetrLowValue, 3);
  			KDetrHighResult = round(KDetrHighValue, 3);
  			MODELAGE.KDetrLabel.setText("K detr                " + KDetrLowResult + " - " + KDetrHighResult);
  			MODELAGE.KDiagLabel.setText("K diag                "  + KDiagLowResult + " - " + KDiagHighResult);
  		} else if (KDiagFixed == true){
  			KDiagLowResult = round(KDiagLowValue, 3);
  			KDiagHighResult = round(KDiagHighValue, 3);
  			KDetrLowResult = round((best_Kdetr_Per_Kdiag*KDiagLowValue), 3);
  			KDetrHighResult = round((best_Kdetr_Per_Kdiag*KDiagHighValue), 3);
  			MODELAGE.KDetrLabel.setText("K detr                " + KDetrLowResult + " - " + KDetrHighResult);
  			MODELAGE.KDiagLabel.setText("K diag                "  + KDiagLowResult + " - " + KDiagHighResult);
  		} else {
  			MODELAGE.KDetrLabel.setText("K detr                ???");
  			MODELAGE.KDiagLabel.setText("K diag                ???");	
  		}
  	//display how good the fit value is	
  		MODELAGE.fitLabel.setText("fit                  " + round(best_Fitness_Value, 2));
  	}
  		    
	/**
	 * method that coordinates results presentation on screen	
	 */
	private static void presentFinalResults(double best_Ar_K_Diag, double best_Ar_K_detr, double best_Kdetr_Per_Kdiag, double best_Fitness_Value){
		double ageDiagFinalSum = 0;
		double ageDiagAverage = 0;
	    double ArKdiagChanged = best_Ar_K_Diag;
	    
	    if (MODELAGE.systematicAgeKnown == true){
	    	ArKdiagChanged = ArKSubstractDetritialComponent(best_Ar_K_Diag, 0,0);//IAA3.systematicError, IAA3.systematicAge);
	    	
	    	for(int z = 0; z < ArPerKDiagFinal.length; z++){
				ageDiagFinalSum += ageCalculate(
				  ArKSubstractDetritialComponent(ArPerKDiagFinal[z], 0, 0));//IAA3.systematicError, IAA3.systematicAge));
	    	}
	    } else {
	    	for(int z = 0; z < ArPerKDiagFinal.length; z++){
				ageDiagFinalSum += ageCalculate(ArPerKDiagFinal[z]);
	    	}
	    }
	    
	    MODELAGE.ArKDiagLabel.setText("40Ar/40K diag   " + round(best_Ar_K_Diag,4));
		ageDiagAverage = ageDiagFinalSum/ArPerKDiagFinal.length;
		double ageDiagDifferenceSum = 0;

		if (MODELAGE.systematicAgeKnown == true){
			for(int z = 0; z < ArPerKDiagFinal.length; z++){
				ageDiagDifferenceSum += Math.pow((ageCalculate(
				  ArKSubstractDetritialComponent(ArPerKDiagFinal[z], 0 ,0))//IAA3.systematicError, IAA3.systematicAge))
				  - ageDiagAverage), 2);
			}
		} else {
			for(int z = 0; z < ArPerKDiagFinal.length; z++){
				ageDiagDifferenceSum += Math.pow((ageCalculate(ArPerKDiagFinal[z])- ageDiagAverage), 2);
			}
		}
		double stdDeviationArPerKDiag = 0;
		if (ArPerKDiagFinal.length > 1){
			stdDeviationArPerKDiag = Math.sqrt((1.0/(double)(ArPerKDiagFinal.length-1))*ageDiagDifferenceSum);
		}

	    	MODELAGE.diagAgeLabel.setText("diagenetic age  " + round(ageDiagAverage,1) + " +- " + round(stdDeviationArPerKDiag,1));

		double ageDetrFinalSum = 0;
		double ageDetrAverage = 0;
		for(int z = 0; z < ArPerKDetrFinal.length; z++){
			ageDetrFinalSum += ageCalculate(ArPerKDetrFinal[z]);
		}
		ageDetrAverage = ageDetrFinalSum/ArPerKDetrFinal.length;
		double ageDetrDifferenceSum = 0;
		for(int z = 0; z < ArPerKDetrFinal.length; z++){
			ageDetrDifferenceSum += Math.pow((ageCalculate(ArPerKDetrFinal[z]) - ageDetrAverage), 2);
		}
		double stdDeviationArPerKDetr = 0;
		if (ArPerKDetrFinal.length > 1){
			stdDeviationArPerKDetr = Math.sqrt((1.0/(double)(ArPerKDetrFinal.length-1))*ageDetrDifferenceSum);
		}
		
	    	MODELAGE.detrAgeLabel.setText("detritial age      " + round(ageDetrAverage,1) + " +- " + round(stdDeviationArPerKDetr,1));
	 
		double KdetrKdiagFinalSum = 0;
		double KdetrKdiagAverage = 0;
		for(int z = 0; z < MODELAGEMinimizing.KdetrPerKdiagFinal.length; z++){
			KdetrKdiagFinalSum += MODELAGEMinimizing.KdetrPerKdiagFinal[z];
		}
		KdetrKdiagAverage = KdetrKdiagFinalSum/MODELAGEMinimizing.KdetrPerKdiagFinal.length;
		double KdetrKdiagDifferenceSum = 0;
		for(int z = 0; z < MODELAGEMinimizing.KdetrPerKdiagFinal.length; z++){
			KdetrKdiagDifferenceSum += Math.pow((MODELAGEMinimizing.KdetrPerKdiagFinal[z] - KdetrKdiagAverage), 2);
		}
		double stdDeviationKdetrKdiag = 0;
		if (MODELAGEMinimizing.KdetrPerKdiagFinal.length > 1){
    		//System.out.print(" in      ");
			stdDeviationKdetrKdiag = Math.sqrt((1.0/(double)(MODELAGEMinimizing.KdetrPerKdiagFinal.length-1))*KdetrKdiagDifferenceSum);
		}
		
	    	MODELAGE.KPerKLabel.setText("K detr / K diag   " + round(KdetrKdiagAverage,2) + " +- " + round(stdDeviationKdetrKdiag,2));
	   	MODELAGE.ArKDetrLabel.setText("40Ar/40K detr   " + round(best_Ar_K_detr,4));

	    	double KDiagLowResult = 0;
		double KDiagHighResult = 0;
		double KDetrLowResult = 0;
		double KDetrHighResult = 0;

		MODELAGE.fitLabel.setText("fit                  " + round(best_Fitness_Value, 2));
		if (KDetrFixed == true && KDiagFixed == true){	   
			if ((KDetrHighValue - KDetrLowValue) < (KDiagHighValue - KDiagLowValue)){
				KDiagLowResult = round((1/best_Kdetr_Per_Kdiag)*KDetrLowValue, 3);
				KDiagHighResult = round((1/best_Kdetr_Per_Kdiag)*KDetrHighValue, 3);
				KDetrLowResult = round(KDetrLowValue, 3);
				KDetrHighResult = round(KDetrHighValue, 3);
			   		if (KDetrLowResult < KDetrLowValue) KDetrLowResult = KDetrLowValue;
			   		if (KDetrHighResult > KDetrHighValue) KDetrHighResult = KDetrHighValue;
			   		if (KDiagLowResult < KDiagLowValue) KDiagLowResult = KDiagLowValue;
			   		if (KDiagHighResult > KDiagHighValue) KDiagHighResult = KDiagHighValue;
		    } else {
		    	KDiagLowResult = round(KDiagLowValue, 3);
		    	KDiagHighResult = round(KDiagHighValue, 3);
		    	KDetrLowResult = round((best_Kdetr_Per_Kdiag*KDiagLowValue), 3);
		    	KDetrHighResult = round((best_Kdetr_Per_Kdiag*KDiagHighValue), 3);
			   		if (KDetrLowResult < KDetrLowValue) KDetrLowResult = KDetrLowValue;
			   		if (KDetrHighResult > KDetrHighValue) KDetrHighResult = KDetrHighValue;
			   		if (KDiagLowResult < KDiagLowValue) KDiagLowResult = KDiagLowValue;
			   		if (KDiagHighResult > KDiagHighValue) KDiagHighResult = KDiagHighValue;
		    }  
			MODELAGE.KDetrLabel.setText("K detr                " + KDetrLowResult + " - " + KDetrHighResult);
			MODELAGE.KDiagLabel.setText("K diag                "  + KDiagLowResult + " - " + KDiagHighResult);
		} else if (KDetrFixed == true){
			KDiagLowResult = round((1/best_Kdetr_Per_Kdiag)*KDetrLowValue, 3);
			KDiagHighResult = round((1/best_Kdetr_Per_Kdiag)*KDetrHighValue, 3);
			KDetrLowResult = round(KDetrLowValue, 3);
			KDetrHighResult = round(KDetrHighValue, 3);
			MODELAGE.KDetrLabel.setText("K detr                " + KDetrLowResult + " - " + KDetrHighResult);
			MODELAGE.KDiagLabel.setText("K diag                "  + KDiagLowResult + " - " + KDiagHighResult);
		} else if (KDiagFixed == true){
			KDiagLowResult = round(KDiagLowValue, 3);
			KDiagHighResult = round(KDiagHighValue, 3);
			KDetrLowResult = round((best_Kdetr_Per_Kdiag*KDiagLowValue), 3);
			KDetrHighResult = round((best_Kdetr_Per_Kdiag*KDiagHighValue), 3);
			MODELAGE.KDetrLabel.setText("K detr                " + KDetrLowResult + " - " + KDetrHighResult);
		   	MODELAGE.KDiagLabel.setText("K diag                "  + KDiagLowResult + " - " + KDiagHighResult);
		} else {
			MODELAGE.KDetrLabel.setText("K detr                ???");
			MODELAGE.KDiagLabel.setText("K diag                ???");	
		}
	}
}///:~




